*
FUNCTION fnGETENV
*
*    THE PURPOSE OF THIS FUNCTION IS TO RETRIEVE THE SPECIFIED ENVIRONMENT
*    VARIABLE, FROM EITHER THE FOXPRO.INI FILE OR FROM GETENV().
*
*    PARAMETERS:
*      cGETENV   -  ENVIRONMENT VARIABLE
*
*    VARIABLES:
*      bGETENV    -  FLAG, GETENV SECTION
*      cDRIV_SEP -  DRIVE & PATH SEPARATOR
*      cPATH_SEP -  PATH SEPARATOR
*      cMEMPATH  -  MEMORY FILE PATH STRING
*      cREC      -  CURRENT RECORD
*      cRETURN   -  RETURNED VALUE
*      nFILE     -  FILE HANDLE
*      nTEMP     -  TEMPORARY VARIABLE
*
PARAMETERS cGETENV
PRIVATE bGETENV, cDRIV_SEP, cPATH_SEP, cMEMPATH, cREC, cRETURN, nFILE, nTEMP

cPATH_SEP = "\"
cDRIV_SEP = ":\"

STORE FULLPATH(SYS(2005)) TO cMEMPATH
IF EMPTY(SYS(2005))  && Foxpro for DOS/Windows 95 bug
  STORE FULLPATH(SYS(2019)) TO cMEMPATH
ENDIF
STORE SUBSTR(cMEMPATH,1,RAT(cPATH_SEP,cMEMPATH)) TO cMEMPATH

IF TYPE("_GETENV") = "U"
  nFILE = FOPEN(cMEMPATH+"FOXPRO.INI")
  IF nFILE > 0
    STORE .F. TO bGETENV
    STORE 0 TO nTEMP
    PUBLIC _GETENV
    DO WHILE .NOT. FEOF(nFILE)
      cREC = ALLTRIM(FGETS(nFILE))
      IF TYPE(cREC) = "C"
        IF bGETENV
          EXIT
        ENDIF
        IF "GETENV" $ UPPER(cREC)
          STORE .T. TO bGETENV
        ENDIF
        LOOP
      ENDIF
      IF bGETENV .AND. "=" $ cREC .AND. LEFT(LTRIM(cREC),1) <> ";"
        nTEMP = nTEMP + 1
        DIMENSION _GETENV(nTEMP,2)
        _GETENV(nTEMP,1) = UPPER(ALLTRIM(  LEFT(cREC,AT("=",cREC)-1)))
        _GETENV(nTEMP,2) =       ALLTRIM(SUBSTR(cREC,AT("=",cREC)+1))
      ENDIF
    ENDDO
    = FCLOSE(nFILE)
  ENDIF
ENDIF
IF TYPE("_GETENV") = "C"
  cGETENV = UPPER(cGETENV)
  nTEMP = ASCAN(_GETENV,cGETENV)
  DO WHILE nTEMP > 0 .AND. ASUBSCRIPT(_GETENV,nTEMP,2) <> 1
    nTEMP = ASCAN(_GETENV,cGETENV,nTEMP+1)
  ENDDO
  IF nTEMP > 0
    cRETURN = _GETENV(nTEMP+1)
  ENDIF
ENDIF
IF TYPE("cRETURN") <> "C"
  cRETURN = IIF(_DOS .OR. _UNIX .OR. _WINDOWS,GETENV(cGETENV),"")
ENDIF
RETURN cRETURN

